#include <string>
#include <map>
#include <list>
using std::string;

class Person {
	string m_name;
	int    m_age;
public:
	Person(const string& name, int age) : m_name(name), m_age(age) {}
	string getName() const { return m_name; }
};

int main() {
	// Key is string, value is pointer to Person
	std::list<Person*> people;
	std::map<std::string, Person*> peopleMap;

	people.push_back(new Person("Jan Prumerny", 27));
	people.push_back(new Person("Michal Vyborny", 31));
	people.push_back(new Person("Tonda Flakac", 29));

	std::list<Person*>::iterator iter;
	for (iter = people.begin(); iter != people.end(); ++iter) {
		Person* tmp = *iter;
		// insert via insert method
		peopleMap.insert(std::pair<std::string, Person*>(tmp->getName(), tmp));
	}
	Person* lenka = new Person("Lenka Slicna", 21);
	peopleMap[lenka->getName()] = lenka;  // insert into map

	// Erase by key
	std::map<std::string, Person*>::iterator iter2;
	iter2 = peopleMap.find("Tonda Flakac");
	if (iter2 != peopleMap.end()) peopleMap.erase(iter2);

	// TODO: add your code below this line to prevent all memory leaks

	people.clear();
	peopleMap.clear();

	return 0;
}

